#pragma once

#include <Arduino.h>

// Reprsentiert eine Spannung in der Einheit mV
class Voltage {
public:
   uint16_t value;
   static const uint16_t epsilon = 50;

   Voltage() : value(0) {}
   Voltage(const uint16_t value) : value(value) {}

   bool operator== (Voltage& rhs) {
      if (rhs.value > value + epsilon) return false;
      if (value > rhs.value + epsilon) return false;
      return true;
   }
   bool operator<(const Voltage& l) { return value + epsilon < l.value; } // mindestens um epsilon kleiner
   bool operator>(const Voltage& l) { return value > l.value + epsilon; } // mindesten um epsilon grer

   operator int() const { return value; }
   Voltage& operator+=(const Voltage& rhs) { this->value += rhs.value; return *this; }
   Voltage& operator-=(const Voltage& rhs) { this->value -= rhs.value; return *this; }
};

inline Voltage operator+(Voltage lhs, const Voltage& rhs) { lhs += rhs; return lhs; }
inline Voltage operator-(Voltage lhs, const Voltage& rhs) { lhs -= rhs; return lhs; }
